## rapmap 0.4.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

enable_testing()

project (RapMap)

set(CPACK_PACKAGE_VERSION "0.4.0")
SET(CPACK_PACKAGE_VERSION_MAJOR "0")
set(CPACK_PACKAGE_VERSION_MINOR "4")
set(CPACK_PACKAGE_VERSION_PATCH "0")
set(PROJECT_VERSION ${CPACK_PACKAGE_VERSION})
set(CPACK_GENERATOR "TGZ")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_PACKAGE_VENDOR "Stony Brook University")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "RapMap - Wicked-fast qasi-mapping")
set(CPACK_PACKAGE_NAME
  "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME
  "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}-Source")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")
#include(FindSSE)
#FindSSE ()
#if(SSE4_2_FOUND)
#    message("Enabling popcount")
#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.2 -DEMPHF_USE_POPCOUNT")
#endif(SSE4_2_FOUND)

if (APPLE)
set (WARNING_IGNORE_FLAGS "-Wno-deprecated-register -Wno-unknon-pragmas -Wreturn-type -Werror=return-type")
else()
set (WARNING_IGNORE_FLAGS "-Wno-unknown-pragmas -Wreturn-type -Werror=return-type")
endif()

## Prefer static to dynamic libraries
SET(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})

## Set the standard required compile flags
if (NO_NATIVE_ARCH)
  message (STATUS "DISABLING NATIVE ARCH.")
else()
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
endif()


if (QUIET_BUILD)
  set(WALL "")
else()
  set(WALL "-Wall")
endif()

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -funroll-loops -fPIC -fomit-frame-pointer -O4 -DHAVE_ANSI_TERM ${WALL} -std=c++11")

##
# OSX is strange (some might say, stupid in this regard).  Deal with it's quirkines here.
##
if (APPLE)
    # To allow ourselves to build a dynamic library, we have to tell the compiler
    # that, yes, the symbols will be around at runtime.
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -undefined dynamic_lookup")
    set (LIBSALMON_LINKER_FLAGS "-all_load")
    # In order to "think different", we also have to use non-standard suffixes
    # for our shared libraries
    set(SHARED_LIB_EXTENSION "dylib")
else()
    # We're in sane linux world
   set (SHARED_LIB_EXTENSION "so")
   set (LIBSALMON_LINKER_FLAGS "")
endif()

set( BOOST_EXTRA_FLAGS "--layout=tagged" )
## this get's set differently below if we
## are on clang & apple
set (NON_APPLECLANG_LIBS gomp rt)
set (PTHREAD_LIB)

##
# Compiler-specific C++11 activation.
# http://stackoverflow.com/questions/10984442/how-to-detect-c11-support-of-a-compiler-with-cmake
##
##
# First take care of what to do if we have gcc
##
set (JELLYFISH_CXX_FLAGS "-fPIC") 
if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU")
    execute_process(
        COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
    # If we're on OSX
    if (APPLE AND NOT (GCC_VERSION VERSION_GREATER 4.8.2 OR GCC_VERSION VERSION_EQUAL 4.8.2))
        message(FATAL_ERROR "When building under OSX, ${PROJECT_NAME} requires "
                            "either clang or g++ >= 4.8.2")
    elseif (NOT (GCC_VERSION VERSION_GREATER 4.7 OR GCC_VERSION VERSION_EQUAL 4.7))
        message(FATAL_ERROR "${PROJECT_NAME} requires g++ 4.7 or greater.")
    endif ()

    set (GCC TRUE)

    # Put complete static linking on hold for the time-being
    # If we're not on OSX, make an attempt to compile everything statically
    #if (NOT APPLE)
    #set (CMAKE_CXX_FLAGS "-static ${CMAKE_CXX_FLAGS}")
    #set (CMAKE_EXE_LINK_FLAGS "-static")
    set (PTHREAD_LIB "pthread")
    #endif()

    # If we're on Linux (i.e. not OSX) and we're using
    # gcc, then set the -static-libstdc++ flag
    if (NOT APPLE)
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libstdc++")
    endif()

    set (WARNING_IGNORE_FLAGS "${WARNING_IGNORE_FLAGS} -Wno-unused-local-typedefs")
# Tentatively, we support clang now
elseif ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
    set(CLANG TRUE)
    # If we have libc++, then try and use it
    include(CheckCXXCompilerFlag)
    check_cxx_compiler_flag(-stdlib=libc++ HAVE_LIBCPP)
    if (HAVE_LIBCPP)
        message ("It appears that you're compiling with clang and that libc++ is available, so I'll use that")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
	set (JELLYFISH_CXX_FLAGS "${JELLYFISH_CXX_FLAGS} -stdlib=libc++")
    # Otherwise, use libstdc++ (and make it static)
    else()
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libstdc++")
    endif()

    if (APPLE)
        set (NON_APPLECLANG_LIBS "")
    else()
        set (PTHREAD_LIB "pthread")
    endif()
else ()
    message(FATAL_ERROR "Your C++ compiler does not support C++11.")
endif ()

include(ExternalProject)

##
#  Update the CXX flags according to the system and compiler
##
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WARNING_IGNORE_FLAGS}")

if (CMAKE_BUILD_TYPE MATCHES Debug)
    message ("Making Debug build")
    set (CMAKE_CXX_FLAGS_DEBUG "-g ${CMAKE_CXX_FLAGS}")
elseif (CMAKE_BUILD_TYPE MATCHES Release)
    message ("Making Release build")
    set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS}")
else ()
    message ("Making Default build type")
endif ()

##
# Record this top-level path
##
set (GAT_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

# Have CMake tell us what it's doing
set (CMAKE_VERBOSE_MAKEFILE true)

find_package (ZLIB)
if (NOT ZLIB_FOUND)
	message (FATAL_ERROR "zlib must be installed before configuration & building can proceed")
endif()


message("Build system will build libdivsufsort")
message("==================================================================")
include(ExternalProject)
ExternalProject_Add(libdivsufsort
    DOWNLOAD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external
    URL ${CMAKE_CURRENT_SOURCE_DIR}/external/libdivsufsort.tar.gz
    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/libdivsufsort-master
    INSTALL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/install
    UPDATE_COMMAND sh -c "mkdir -p <SOURCE_DIR>/build"
    BINARY_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/libdivsufsort-master/build
    CMAKE_ARGS -DCMAKE_INSTALL_PREFIX:PATH=<INSTALL_DIR> -DBUILD_DIVSUFSORT64=TRUE -DUSE_OPENMP=TRUE -DBUILD_SHARED_LIBS=FALSE
)
set(SUFFARRAY_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/external/install/include)

if (NOT CEREAL_ROOT)
	set(CEREAL_ROOT ${GAT_SOURCE_DIR}/external/install)
endif()

find_package (Cereal 1.1.2)
if (NOT CEREAL_FOUND)

	message("Build system will fetch and build the Cereal serialization library")
	message("==================================================================")
	include(ExternalProject)
	ExternalProject_Add(libcereal
	    DOWNLOAD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external
	    DOWNLOAD_COMMAND curl -k -L https://github.com/USCiLab/cereal/archive/v1.1.2.tar.gz -o cereal-v1.1.2.tar.gz &&
		tar -xzvf cereal-v1.1.2.tar.gz
	    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/cereal-1.1.2
	    INSTALL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/install
	    UPDATE_COMMAND sh -c "mkdir -p <SOURCE_DIR>/build"
	    BINARY_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/cereal-1.1.2/build
	    CONFIGURE_COMMAND ""
	    BUILD_COMMAND ""
	    INSTALL_COMMAND sh -c "mkdir -p <INSTALL_DIR>/include && cp -r <SOURCE_DIR>/include/cereal <INSTALL_DIR>/include"
	)

	set(CEREAL_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/external/install/include)

endif()


if (NOT JELLYFISH_ROOT)
	set(JELLYFISH_ROOT ${GAT_SOURCE_DIR}/external/install)
endif()

find_package(Jellyfish 2.2.5)

if (NOT JELLYFISH_FOUND)
message("Build system will fetch and build Jellyfish")
message("==================================================================")
ExternalProject_Add(libjellyfish
    DOWNLOAD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external
    DOWNLOAD_COMMAND curl -k -L https://github.com/gmarcais/Jellyfish/releases/download/v2.2.5/jellyfish-2.2.5.tar.gz -o jellyfish-2.2.5.tgz &&
    	rm -fr jellyfish-2.2.5 &&
     	tar -xzvf jellyfish-2.2.5.tgz
    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/jellyfish-2.2.5
    INSTALL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/install
    CONFIGURE_COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/external/jellyfish-2.2.5/configure --enable-shared=no --prefix=<INSTALL_DIR> CC=${CMAKE_C_COMPILER} CXX=${CMAKE_CXX_COMPILER} CXXFLAGS=${JELLYFISH_CXX_FLAGS}
    BUILD_COMMAND ${MAKE} CC=${CMAKE_C_COMPILER} CXX=${CMAKE_CXX_COMPILER} CXXFLAGS=${JELLYFISH_CXX_FLAGS}
    BUILD_IN_SOURCE 1
    INSTALL_COMMAND make install
)
endif()

set (FAST_MALLOC_LIB "")
set (HAVE_FAST_MALLOC FALSE)

# See if we have Jemalloc
find_package(Jemalloc)
if (Jemalloc_FOUND)
    message("Found Jemalloc library --- using this memory allocator")
    set (FAST_MALLOC_LIB ${JEMALLOC_LIBRARIES})
    set (HAVE_FAST_MALLOC TRUE)
endif()

if (NOT HAVE_FAST_MALLOC)
    # See if we have Tcmalloc
    find_package(Tcmalloc)
    if (Tcmalloc_FOUND)
        message("Fount TCMalloc library --- using this memory allocator")
        set (TCMALLOC_LIB ${Tcmalloc_LIBRARIES})
        set (FAST_MALLOC_LIB ${TCMALLOC_LIB})
        set (HAVE_FAST_MALLOC TRUE)
    endif()
endif()

if (NOT HAVE_FAST_MALLOC)
    message("Build system will fetch and use JEMalloc")
    message("==================================================================")
    ExternalProject_Add(libjemalloc
        DOWNLOAD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external
        DOWNLOAD_COMMAND curl -k -L https://github.com/COMBINE-lab/jemalloc/archive/3.6.0.tar.gz -o jemalloc-3.6.0.tar.gz &&
        tar -xzf jemalloc-3.6.0.tar.gz
        SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/jemalloc-3.6.0
        BUILD_IN_SOURCE TRUE
        INSTALL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/install
        CONFIGURE_COMMAND sh -c "CC=${CMAKE_C_COMPILER} ./autogen.sh --prefix=<INSTALL_DIR>"
        INSTALL_COMMAND cp -r lib <INSTALL_DIR>/ && cp -r include <INSTALL_DIR>/
        )

    set (FAST_MALLOC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/external/install/lib/libjemalloc.a)
    set (HAVE_FAST_MALLOC TRUE)
endif ()

###
#
# Done building external dependencies.
#
###

set (CPACK_SOURCE_IGNORE_FILES
".git/")

message("CPACK_SOURCE_IGNORE_FILES = ${CPACK_SOURCE_IGNORE_FILES}")

# Recurse into Salmon source directory
add_subdirectory ( src )

# build a CPack driven installer package
include (CPack)

set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${PROJECT_VERSION})
add_custom_target(dist
        COMMAND git archive --prefix=${ARCHIVE_NAME}/ HEAD
        | gzip > ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.gz
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

=== src/CMakeLists.txt ===
set (RAPMAP_MAIN_SRCS
    RapMap.cpp
    RapMapIndexer.cpp
    RapMapSAIndexer.cpp
    RapMapUtils.cpp
    RapMapMapper.cpp
    RapMapSAMapper.cpp
    RapMapFileSystem.cpp
    RapMapSAIndex.cpp
    RapMapIndex.cpp
    HitManager.cpp
    FastxParser.cpp
    rank9b.cpp
    stringpiece.cc
    xxhash.c
    bit_array.c
)

set (RAPMAP_ALIGN_SRCS
)

set (RAPMAP_LIB_SRCS
)

#set (RSDICT_LIB_SRCS
#    EnumCoder.cpp
#    RSDic.cpp
#    RSDicBuilder.cpp
#)

include_directories(
${GAT_SOURCE_DIR}/include
${GAT_SOURCE_DIR}/external
${GAT_SOURCE_DIR}/external/cereal/include
${GAT_SOURCE_DIR}/external/install/include
${GAT_SOURCE_DIR}/external/install/include/jellyfish-2.2.5
${ZLIB_INCLUDE_DIR}
${CEREAL_INCLUDE_DIRS}
)

if (JELLYFISH_FOUND)
    include_directories(${JELLYFISH_INCLUDE_DIR})
else()
    include_directories(${GAT_SOURCE_DIR}/external/install/include/jellyfish-2.2.5)
endif()

link_directories(
${GAT_SOURCE_DIR}/lib
${GAT_SOURCE_DIR}/external/install/lib
#${Boost_LIBRARY_DIRS}
#${TBB_LIBRARY_DIRS}
#${LAPACK_LIBRARY_DIR}
#${BLAS_LIBRARY_DIR}
)

# Set the RPATH
if (NOT APPLE)
    set(CMAKE_INSTALL_RPATH "$ORIGIN/../lib:$ORIGIN/../../lib:$ORIGIN/:$ORIGIN/../../external/install/lib")
    set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
else()
  # use, i.e. don't skip the full RPATH for the build tree
  set(CMAKE_SKIP_BUILD_RPATH  FALSE)

  # when building, don't use the install RPATH already
  # (but later on when installing)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

  # the RPATH to be used when installing
  set(CMAKE_INSTALL_RPATH "")

  # don't add the automatically determined parts of the RPATH
  # which point to directories outside the build tree to the install RPATH
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
endif()

# Build the rapmap executable
add_executable(rapmap ${RAPMAP_MAIN_SRCS})

# our suffix array construction libraries
set (SUFFARRAY_LIB ${GAT_SOURCE_DIR}/external/install/lib/libdivsufsort.a)
set (SUFFARRAY64_LIB ${GAT_SOURCE_DIR}/external/install/lib/libdivsufsort64.a)

# Link the executable
target_link_libraries(rapmap
    ${PTHREAD_LIB}
    ${ZLIB_LIBRARY}
    ${SUFFARRAY_LIB}
    ${SUFFARRAY64_LIB}
    ${GAT_SOURCE_DIR}/external/install/lib/libjellyfish-2.0.a
    m
    ${LIBLZMA_LIBRARIES}
    ${NON_APPLECLANG_LIBS}
    ${FAST_MALLOC_LIB}
)


##### ======================================
IF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  SET(CMAKE_INSTALL_PREFIX
    "${GAT_SOURCE_DIR}" CACHE PATH "Default install prefix" FORCE
    )
ENDIF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

set(INSTALL_LIB_DIR lib )
set(INSTALL_BIN_DIR bin )
set(INSTALL_INCLUDE_DIR include )

# install(FILES ${Boost_LIBRARIES}
# 	           DESTINATION ${INSTALL_LIB_DIR})

install(TARGETS rapmap 
                RUNTIME DESTINATION bin
                LIBRARY DESTINATION lib
                ARCHIVE DESTINATION lib
        )

install(FILES ${GAT_SOURCE_DIR}/scripts/RunRapMap.sh 
              PERMISSIONS WORLD_EXECUTE WORLD_READ OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
              DESTINATION bin)
    #set(POST_INSTALL_SCRIPT ${GAT_SOURCE_DIR}/cmake/PostInstall.cmake)

    #install(
    #    CODE
    #    "
    #    execute_process(COMMAND \"${CMAKE_COMMAND}\"
    #                            -DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}
    #                            -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}
    #                            -P \"${POST_INSTALL_SCRIPT}\")
    #    "
    #)
    #
    #include(InstallRequiredSystemLibraries)
    #add_test( NAME salmon_read_test COMMAND ${CMAKE_COMMAND} -DTOPLEVEL_DIR=${GAT_SOURCE_DIR} -P ${GAT_SOURCE_DIR}/cmake/TestSalmon.cmake )

=== debian/changelog ===
rapmap (0.4.0+dfsg-2) unstable; urgency=medium

  * Set NO_NATIVE_ARCH=true
    Closes: #847084
  * Do not try downloading libjemalloc
    Closes: #847083
  * debhelper 10
  * d/watch: version=4
  * hardening=+all

 -- Andreas Tille <tille@debian.org>  Mon, 05 Dec 2016 16:32:20 +0100

rapmap (0.4.0+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Prefer dynamic to static libraries

 -- Andreas Tille <tille@debian.org>  Mon, 17 Oct 2016 16:06:53 +0200

rapmap (0.3.0+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #836914)

 -- Andreas Tille <tille@debian.org>  Wed, 07 Sep 2016 10:03:37 +0200

=== debian/control ===
Source: rapmap
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake,
               zlib1g-dev,
               libdivsufsort-dev,
               libcereal-dev,
               libjellyfish-2.0-dev,
               libjemalloc-dev,
               libsparsehash-dev,
               libspdlog-dev,
               libtclap-dev,
               pkg-config,
               python-markdown
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/rapmap.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/rapmap.git
Homepage: https://github.com/COMBINE-lab/RapMap

Package: rapmap
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: rapid sensitive and accurate DNA read mapping via quasi-mapping
 RapMap is a testing ground for ideas in quasi-mapping / (lightweight /
 pseudo) transcriptome alignment. That means that, at this point, it is
 somewhat experimental. The develop branch will have the latest
 improvements and additions, but is not guaranteed to be stable between
 commits. Breaking changes to the master branch will be accompanied by a
 tag to the version before the breaking change. Currently, RapMap is a
 stand-alone quasi-mapper that can be used with other tools. It is also
 being used as part of Sailfish and Salmon. Eventually, the hope is to
 create and stabilize an API so that it can be used as a library from
 other tools.
 .
 Quasi-mapping / (lightweight / pseudo)-alignment is the term that is
 used here for the type of information required for certain tasks (e.g.
 transcript quantification) that is less "heavyweight" than what is
 provided by traditional alignment. For example, one may only need to
 know the transcripts / contigs to which a read aligns and, perhaps, the
 position within those transcripts rather than the optimal alignment and
 base-for-base CIGAR string that aligns the read and substring of the
 transcript. For details on RapMap (quasi-mapping in particular), please
 check out the associated paper. Note: RapMap implements both quasi-
 mapping and pseudo-alignment (originally introduced in Bray et al.
 2016), these two are not the same thing. They are distinct concepts, and
 RapMap simply happens to implement algorithms for computing both.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DJELLYFISH_ROOT=/usr -DNO_NATIVE_ARCH=true

override_dh_auto_build:
	dh_auto_build
	markdown_py -f README.html README.md

## rapmap 0.5.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,9 +4,9 @@
 
 project (RapMap)
 
-set(CPACK_PACKAGE_VERSION "0.4.0")
+set(CPACK_PACKAGE_VERSION "0.5.0")
 SET(CPACK_PACKAGE_VERSION_MAJOR "0")
-set(CPACK_PACKAGE_VERSION_MINOR "4")
+set(CPACK_PACKAGE_VERSION_MINOR "5")
 set(CPACK_PACKAGE_VERSION_PATCH "0")
 set(PROJECT_VERSION ${CPACK_PACKAGE_VERSION})
 set(CPACK_GENERATOR "TGZ")
@@ -50,6 +50,9 @@
 endif()
 
 set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -funroll-loops -fPIC -fomit-frame-pointer -O4 -DHAVE_ANSI_TERM ${WALL} -std=c++11")
+
+set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
+find_package(Threads REQUIRED)
 
 ##
 # OSX is strange (some might say, stupid in this regard).  Deal with it's quirkines here.
@@ -159,7 +162,7 @@
 # Have CMake tell us what it's doing
 set (CMAKE_VERBOSE_MAKEFILE true)
 
-find_package (ZLIB)
+find_package (ZLIB REQUIRED)
 if (NOT ZLIB_FOUND)
 	message (FATAL_ERROR "zlib must be installed before configuration & building can proceed")
 endif()
@@ -183,7 +186,7 @@
 	set(CEREAL_ROOT ${GAT_SOURCE_DIR}/external/install)
 endif()
 
-find_package (Cereal 1.1.2)
+find_package (Cereal 1.2.2)
 if (NOT CEREAL_FOUND)
 
 	message("Build system will fetch and build the Cereal serialization library")
@@ -191,12 +194,12 @@
 	include(ExternalProject)
 	ExternalProject_Add(libcereal
 	    DOWNLOAD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external
-	    DOWNLOAD_COMMAND curl -k -L https://github.com/USCiLab/cereal/archive/v1.1.2.tar.gz -o cereal-v1.1.2.tar.gz &&
-		tar -xzvf cereal-v1.1.2.tar.gz
-	    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/cereal-1.1.2
+	    DOWNLOAD_COMMAND curl -k -L https://github.com/USCiLab/cereal/archive/v1.2.2.tar.gz -o cereal-v1.2.2.tar.gz &&
+		tar -xzvf cereal-v1.2.2.tar.gz
+	    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/cereal-1.2.2
 	    INSTALL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/install
 	    UPDATE_COMMAND sh -c "mkdir -p <SOURCE_DIR>/build"
-	    BINARY_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/cereal-1.1.2/build
+	    BINARY_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/cereal-1.2.2/build
 	    CONFIGURE_COMMAND ""
 	    BUILD_COMMAND ""
 	    INSTALL_COMMAND sh -c "mkdir -p <INSTALL_DIR>/include && cp -r <SOURCE_DIR>/include/cereal <INSTALL_DIR>/include"
@@ -211,20 +214,20 @@
 	set(JELLYFISH_ROOT ${GAT_SOURCE_DIR}/external/install)
 endif()
 
-find_package(Jellyfish 2.2.5)
+find_package(Jellyfish 2.2.6)
 
 if (NOT JELLYFISH_FOUND)
 message("Build system will fetch and build Jellyfish")
 message("==================================================================")
 ExternalProject_Add(libjellyfish
     DOWNLOAD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external
-    DOWNLOAD_COMMAND curl -k -L https://github.com/gmarcais/Jellyfish/releases/download/v2.2.5/jellyfish-2.2.5.tar.gz -o jellyfish-2.2.5.tgz &&
-    	rm -fr jellyfish-2.2.5 &&
-     	tar -xzvf jellyfish-2.2.5.tgz
-    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/jellyfish-2.2.5
+    DOWNLOAD_COMMAND curl -k -L https://github.com/gmarcais/Jellyfish/releases/download/v2.2.6/jellyfish-2.2.6.tar.gz -o jellyfish-2.2.6.tgz &&
+    	rm -fr jellyfish-2.2.6 &&
+     	tar -xzvf jellyfish-2.2.6.tgz
+    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/jellyfish-2.2.6
     INSTALL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/install
-    CONFIGURE_COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/external/jellyfish-2.2.5/configure --enable-shared=no --prefix=<INSTALL_DIR> CC=${CMAKE_C_COMPILER} CXX=${CMAKE_CXX_COMPILER} CXXFLAGS=${JELLYFISH_CXX_FLAGS}
-    BUILD_COMMAND ${MAKE} CC=${CMAKE_C_COMPILER} CXX=${CMAKE_CXX_COMPILER} CXXFLAGS=${JELLYFISH_CXX_FLAGS}
+    CONFIGURE_COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/external/jellyfish-2.2.6/configure --enable-shared=no --prefix=<INSTALL_DIR> CC=${CMAKE_C_COMPILER} CXX=${CMAKE_CXX_COMPILER} CXXFLAGS=${JELLYFISH_CXX_FLAGS}
+    BUILD_COMMAND make CC=${CMAKE_C_COMPILER} CXX=${CMAKE_CXX_COMPILER} CXXFLAGS=${JELLYFISH_CXX_FLAGS}
     BUILD_IN_SOURCE 1
     INSTALL_COMMAND make install
 )
@@ -257,12 +260,12 @@
     message("==================================================================")
     ExternalProject_Add(libjemalloc
         DOWNLOAD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external
-        DOWNLOAD_COMMAND curl -k -L https://github.com/COMBINE-lab/jemalloc/archive/3.6.0.tar.gz -o jemalloc-3.6.0.tar.gz &&
-        tar -xzf jemalloc-3.6.0.tar.gz
-        SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/jemalloc-3.6.0
+        DOWNLOAD_COMMAND curl -k -L https://github.com/COMBINE-lab/jemalloc/archive/4.5.0.tar.gz -o jemalloc-4.5.0.tar.gz &&
+                         tar -xzf jemalloc-4.5.0.tar.gz
+        SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/jemalloc-4.5.0
         BUILD_IN_SOURCE TRUE
         INSTALL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/install
-        CONFIGURE_COMMAND sh -c "CC=${CMAKE_C_COMPILER} ./autogen.sh --prefix=<INSTALL_DIR>"
+        CONFIGURE_COMMAND sh -c "${JEMALLOC_FLAGS} ./autogen.sh --disable-debug --prefix=<INSTALL_DIR>"
         INSTALL_COMMAND cp -r lib <INSTALL_DIR>/ && cp -r include <INSTALL_DIR>/
         )

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -33,7 +33,7 @@
 ${GAT_SOURCE_DIR}/external
 ${GAT_SOURCE_DIR}/external/cereal/include
 ${GAT_SOURCE_DIR}/external/install/include
-${GAT_SOURCE_DIR}/external/install/include/jellyfish-2.2.5
+${GAT_SOURCE_DIR}/external/install/include/jellyfish-2.2.6
 ${ZLIB_INCLUDE_DIR}
 ${CEREAL_INCLUDE_DIRS}
 )
@@ -41,7 +41,7 @@
 if (JELLYFISH_FOUND)
     include_directories(${JELLYFISH_INCLUDE_DIR})
 else()
-    include_directories(${GAT_SOURCE_DIR}/external/install/include/jellyfish-2.2.5)
+    include_directories(${GAT_SOURCE_DIR}/external/install/include/jellyfish-2.2.6)
 endif()
 
 link_directories(
@@ -82,15 +82,16 @@
 
 # Link the executable
 target_link_libraries(rapmap
-    ${PTHREAD_LIB}
+    # ${PTHREAD_LIB}
     ${ZLIB_LIBRARY}
     ${SUFFARRAY_LIB}
     ${SUFFARRAY64_LIB}
     ${GAT_SOURCE_DIR}/external/install/lib/libjellyfish-2.0.a
     m
-    ${LIBLZMA_LIBRARIES}
+    #${LIBLZMA_LIBRARIES}
     ${NON_APPLECLANG_LIBS}
     ${FAST_MALLOC_LIB}
+    ${CMAKE_THREAD_LIBS_INIT}
 )
 
 
@@ -130,4 +131,5 @@
     #)
     #
     #include(InstallRequiredSystemLibraries)
-    #add_test( NAME salmon_read_test COMMAND ${CMAKE_COMMAND} -DTOPLEVEL_DIR=${GAT_SOURCE_DIR} -P ${GAT_SOURCE_DIR}/cmake/TestSalmon.cmake )
+    add_test( NAME quasi_map_test COMMAND ${CMAKE_COMMAND} -DTOPLEVEL_DIR=${GAT_SOURCE_DIR} -P ${GAT_SOURCE_DIR}/cmake/TestQuasiMap.cmake )
+    add_test( NAME quasi_map_test_ph COMMAND ${CMAKE_COMMAND} -DTOPLEVEL_DIR=${GAT_SOURCE_DIR} -P ${GAT_SOURCE_DIR}/cmake/TestQuasiMapPerfectHash.cmake )

=== debian/changelog ===
rapmap (0.5.0+dfsg-3) unstable; urgency=medium

  * Team upload

  [ Andreas Tille ]
  * Add binary package containing example data
  * debhelper 11
  * Standards-Version: 4.1.3

  [ Katerina Kalou ]
  * Provide autopkgtest
    Closes: #879616

 -- Katerina Kalou <aik.kalou@gmail.com>  Fri, 12 Jan 2018 18:55:20 +0100

rapmap (0.5.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * d/p/libspdlog: Correct instanziation of ansicolor sink, Closes: #884218

 -- Gert Wollny <gewo@debian.org>  Wed, 13 Dec 2017 11:24:03 +0100

rapmap (0.5.0+dfsg-1) unstable; urgency=medium

  * Team upload.

  * New upstream version.
  * Added references to registries.
  * Bumped policy to 4.1.1.1 (no changes required).

  * Removing files created during build in debian/rules clean target

 -- Steffen Moeller <moeller@debian.org>  Sun, 22 Oct 2017 21:19:17 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11),
                cmake,
                zlib1g-dev,
                libdivsufsort-dev,
@@ -15,7 +15,7 @@
                libtclap-dev,
                pkg-config,
                python-markdown
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/rapmap.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/rapmap.git
 Homepage: https://github.com/COMBINE-lab/RapMap
@@ -48,3 +48,21 @@
  mapping and pseudo-alignment (originally introduced in Bray et al.
  2016), these two are not the same thing. They are distinct concepts, and
  RapMap simply happens to implement algorithms for computing both.
+
+Package: rapmap-example-data
+Architecture: all
+Depends: ${misc:Depends}
+Recommends: rapmap
+Description: example data for rapmap - rapid sensitive and accurate DNA read mapping
+ RapMap is a testing ground for ideas in quasi-mapping / (lightweight /
+ pseudo) transcriptome alignment. That means that, at this point, it is
+ somewhat experimental. The develop branch will have the latest
+ improvements and additions, but is not guaranteed to be stable between
+ commits. Breaking changes to the master branch will be accompanied by a
+ tag to the version before the breaking change. Currently, RapMap is a
+ stand-alone quasi-mapper that can be used with other tools. It is also
+ being used as part of Sailfish and Salmon. Eventually, the hope is to
+ create and stabilize an API so that it can be used as a library from
+ other tools.
+ .
+ This package contains example data to test this program.

=== debian/rules ===
--- 
+++ 
@@ -14,3 +14,8 @@
 override_dh_auto_build:
 	dh_auto_build
 	markdown_py -f README.html README.md
+
+override_dh_clean:
+	dh_clean README.html sample_data/sample_quasi_index/ sample_data/sample_quasi_index_ph/ sample_data/sample_quasi_map.sam sample_data/sample_quasi_map_ph.sam
+
+

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
   https://github.com/COMBINE-lab/RapMap/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## rapmap 0.12.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,18 +1,18 @@
-cmake_minimum_required (VERSION 2.8)
+cmake_minimum_required (VERSION 3.1)
 
 enable_testing()
 
 project (RapMap)
 
-set(CPACK_PACKAGE_VERSION "0.5.0")
+set(CPACK_PACKAGE_VERSION "0.6.0")
 SET(CPACK_PACKAGE_VERSION_MAJOR "0")
-set(CPACK_PACKAGE_VERSION_MINOR "5")
+set(CPACK_PACKAGE_VERSION_MINOR "6")
 set(CPACK_PACKAGE_VERSION_PATCH "0")
 set(PROJECT_VERSION ${CPACK_PACKAGE_VERSION})
 set(CPACK_GENERATOR "TGZ")
 set(CPACK_SOURCE_GENERATOR "TGZ")
 set(CPACK_PACKAGE_VENDOR "Stony Brook University")
-set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "RapMap - Wicked-fast qasi-mapping")
+set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "RapMap - Wicked-fast quasi-mapping")
 set(CPACK_PACKAGE_NAME
   "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 set(CPACK_SOURCE_PACKAGE_FILE_NAME
@@ -46,10 +46,10 @@
 if (QUIET_BUILD)
   set(WALL "")
 else()
-  set(WALL "-Wall")
-endif()
-
-set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -funroll-loops -fPIC -fomit-frame-pointer -O4 -DHAVE_ANSI_TERM ${WALL} -std=c++11")
+  set(WALL "-Wall -Wno-unused-function -Wno-unused-local-typedef")
+endif()
+
+set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -funroll-loops -fPIC -fomit-frame-pointer -O4 -DHAVE_ANSI_TERM ${WALL} -std=c++14")
 
 set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
 find_package(Threads REQUIRED)
@@ -89,11 +89,11 @@
     execute_process(
         COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
     # If we're on OSX
-    if (APPLE AND NOT (GCC_VERSION VERSION_GREATER 4.8.2 OR GCC_VERSION VERSION_EQUAL 4.8.2))
+    if (APPLE AND NOT (GCC_VERSION VERSION_GREATER 5.2 OR GCC_VERSION VERSION_EQUAL 5.2))
         message(FATAL_ERROR "When building under OSX, ${PROJECT_NAME} requires "
-                            "either clang or g++ >= 4.8.2")
-    elseif (NOT (GCC_VERSION VERSION_GREATER 4.7 OR GCC_VERSION VERSION_EQUAL 4.7))
-        message(FATAL_ERROR "${PROJECT_NAME} requires g++ 4.7 or greater.")
+                            "either clang or g++ >= 5.2")
+    elseif (NOT (GCC_VERSION VERSION_GREATER 5.2 OR GCC_VERSION VERSION_EQUAL 5.2))
+        message(FATAL_ERROR "${PROJECT_NAME} requires g++ 5.2 or greater.")
     endif ()
 
     set (GCC TRUE)
@@ -134,7 +134,7 @@
         set (PTHREAD_LIB "pthread")
     endif()
 else ()
-    message(FATAL_ERROR "Your C++ compiler does not support C++11.")
+    message(FATAL_ERROR "Your C++ compiler does not support C++14.")
 endif ()
 
 include(ExternalProject)
@@ -209,50 +209,29 @@
 
 endif()
 
-
-if (NOT JELLYFISH_ROOT)
-	set(JELLYFISH_ROOT ${GAT_SOURCE_DIR}/external/install)
-endif()
-
-find_package(Jellyfish 2.2.6)
-
-if (NOT JELLYFISH_FOUND)
-message("Build system will fetch and build Jellyfish")
-message("==================================================================")
-ExternalProject_Add(libjellyfish
-    DOWNLOAD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external
-    DOWNLOAD_COMMAND curl -k -L https://github.com/gmarcais/Jellyfish/releases/download/v2.2.6/jellyfish-2.2.6.tar.gz -o jellyfish-2.2.6.tgz &&
-    	rm -fr jellyfish-2.2.6 &&
-     	tar -xzvf jellyfish-2.2.6.tgz
-    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/jellyfish-2.2.6
-    INSTALL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/install
-    CONFIGURE_COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/external/jellyfish-2.2.6/configure --enable-shared=no --prefix=<INSTALL_DIR> CC=${CMAKE_C_COMPILER} CXX=${CMAKE_CXX_COMPILER} CXXFLAGS=${JELLYFISH_CXX_FLAGS}
-    BUILD_COMMAND make CC=${CMAKE_C_COMPILER} CXX=${CMAKE_CXX_COMPILER} CXXFLAGS=${JELLYFISH_CXX_FLAGS}
-    BUILD_IN_SOURCE 1
-    INSTALL_COMMAND make install
-)
-endif()
-
 set (FAST_MALLOC_LIB "")
 set (HAVE_FAST_MALLOC FALSE)
+
 
 # See if we have Jemalloc
 find_package(Jemalloc)
 if (Jemalloc_FOUND)
+  ##
+  # Don't be so stringent about the version yet
+  ##
+  #if (NOT (${JEMALLOC_VERSION} VERSION_LESS 5.1.0))
     message("Found Jemalloc library --- using this memory allocator")
     set (FAST_MALLOC_LIB ${JEMALLOC_LIBRARIES})
     set (HAVE_FAST_MALLOC TRUE)
-endif()
-
-if (NOT HAVE_FAST_MALLOC)
-    # See if we have Tcmalloc
-    find_package(Tcmalloc)
-    if (Tcmalloc_FOUND)
-        message("Fount TCMalloc library --- using this memory allocator")
-        set (TCMALLOC_LIB ${Tcmalloc_LIBRARIES})
-        set (FAST_MALLOC_LIB ${TCMALLOC_LIB})
-        set (HAVE_FAST_MALLOC TRUE)
-    endif()
+  #else()
+  #  message("Fond Jemalloc version ${JEMALLOC_VERSION}, but require >= 5.1.0. Downloading newer version")
+  #endif()
+endif()
+
+if(CONDA_BUILD)
+  set (JEMALLOC_FLAGS "CC=${CMAKE_C_COMPILER} CFLAGS=-fPIC CPPFLAGS=-fPIC")
+else ()
+  set (JEMALLOC_FLAGS "CC=${CMAKE_C_COMPILER}")
 endif()
 
 if (NOT HAVE_FAST_MALLOC)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,19 +1,19 @@
 set (RAPMAP_MAIN_SRCS
     RapMap.cpp
-    RapMapIndexer.cpp
     RapMapSAIndexer.cpp
     RapMapUtils.cpp
-    RapMapMapper.cpp
     RapMapSAMapper.cpp
     RapMapFileSystem.cpp
     RapMapSAIndex.cpp
-    RapMapIndex.cpp
     HitManager.cpp
     FastxParser.cpp
     rank9b.cpp
     stringpiece.cc
     xxhash.c
     bit_array.c
+    #RapMapIndex.cpp
+    #RapMapMapper.cpp
+    #RapMapIndexer.cpp
 )
 
 set (RAPMAP_ALIGN_SRCS
@@ -22,35 +22,19 @@
 set (RAPMAP_LIB_SRCS
 )
 
-#set (RSDICT_LIB_SRCS
-#    EnumCoder.cpp
-#    RSDic.cpp
-#    RSDicBuilder.cpp
-#)
-
 include_directories(
 ${GAT_SOURCE_DIR}/include
+${GAT_SOURCE_DIR}/digestpp
 ${GAT_SOURCE_DIR}/external
 ${GAT_SOURCE_DIR}/external/cereal/include
 ${GAT_SOURCE_DIR}/external/install/include
-${GAT_SOURCE_DIR}/external/install/include/jellyfish-2.2.6
 ${ZLIB_INCLUDE_DIR}
 ${CEREAL_INCLUDE_DIRS}
 )
 
-if (JELLYFISH_FOUND)
-    include_directories(${JELLYFISH_INCLUDE_DIR})
-else()
-    include_directories(${GAT_SOURCE_DIR}/external/install/include/jellyfish-2.2.6)
-endif()
-
 link_directories(
 ${GAT_SOURCE_DIR}/lib
 ${GAT_SOURCE_DIR}/external/install/lib
-#${Boost_LIBRARY_DIRS}
-#${TBB_LIBRARY_DIRS}
-#${LAPACK_LIBRARY_DIR}
-#${BLAS_LIBRARY_DIR}
 )
 
 # Set the RPATH
@@ -86,14 +70,21 @@
     ${ZLIB_LIBRARY}
     ${SUFFARRAY_LIB}
     ${SUFFARRAY64_LIB}
-    ${GAT_SOURCE_DIR}/external/install/lib/libjellyfish-2.0.a
     m
-    #${LIBLZMA_LIBRARIES}
     ${NON_APPLECLANG_LIBS}
     ${FAST_MALLOC_LIB}
     ${CMAKE_THREAD_LIBS_INIT}
+    #${GAT_SOURCE_DIR}/external/install/lib/libjellyfish-2.0.a
+    #${LIBLZMA_LIBRARIES}
 )
 
+##
+# External dependencies of salmon_core and salmon
+##
+if (${FETCHED_JEMALLOC})
+   add_dependencies(rapmap libjemalloc)
+   add_dependencies(rapmap libjemalloc)
+endif()
 
 ##### ======================================
 IF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

=== debian/changelog ===
rapmap (0.12.0+dfsg-3) unstable; urgency=medium

  * debian/patches/portable_pause: add ppc64el and arm64 alternatives to
    asm("pause").
  * debian/patches/no_gomp_needed: Avoid unnecessary linkage to gomp.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 02 Jan 2019 03:07:04 -0800

rapmap (0.12.0+dfsg-2) unstable; urgency=medium

  * Add further header files to rapmap-dev since these are used in salmon

 -- Andreas Tille <tille@debian.org>  Thu, 13 Dec 2018 15:37:29 +0100

rapmap (0.12.0+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1
  * Remove trailing whitespace in debian/rules
  * For some reason rapmap releases are prefixed by "salmon-" - adapt
    watch file
  * Do not exclude spdlog any more as long as it is not ported to
    version spdlog 1.2.x
    Closes: #909766
  * Add rapmap-dev package to simplify building salmon and avoid code
    duplication in salmon package source
  * Lintian override for script-with-language-extension
  * Avoid privacy breach

 -- Andreas Tille <tille@debian.org>  Wed, 12 Dec 2018 23:05:04 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: rapmap
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Michael R. Crusoe <michael.crusoe@gmail.com>
 Section: science
 Priority: optional
 Build-Depends: debhelper (>= 11),
@@ -15,9 +16,9 @@
                libtclap-dev,
                pkg-config,
                python-markdown
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/rapmap.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/rapmap.git
+Standards-Version: 4.3.0
+Vcs-Browser: https://salsa.debian.org/med-team/rapmap
+Vcs-Git: https://salsa.debian.org/med-team/rapmap.git
 Homepage: https://github.com/COMBINE-lab/RapMap
 
 Package: rapmap
@@ -66,3 +67,23 @@
  other tools.
  .
  This package contains example data to test this program.
+
+Package: rapmap-dev
+Architecture: all
+Depends: ${misc:Depends}
+Description: rapmap - rapid sensitive and accurate DNA read mapping (some headers)
+ RapMap is a testing ground for ideas in quasi-mapping / (lightweight /
+ pseudo) transcriptome alignment. That means that, at this point, it is
+ somewhat experimental. The develop branch will have the latest
+ improvements and additions, but is not guaranteed to be stable between
+ commits. Breaking changes to the master branch will be accompanied by a
+ tag to the version before the breaking change. Currently, RapMap is a
+ stand-alone quasi-mapper that can be used with other tools. It is also
+ being used as part of Sailfish and Salmon. Eventually, the hope is to
+ create and stabilize an API so that it can be used as a library from
+ other tools.
+ .
+ This package contains some headers and C++ source files which are
+ included by package salmon and are provided here in an accessible
+ way to avoid code duplication.  Usually there is no reason to install
+ this package except to build the salmon package.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

ifneq (,$(filter $(DEB_HOST_ARCH),arm64 ppc64el))
	export NON_APPLECLANG_LIBS=z
	# not really z, but we need something innocent here
else
	export NON_APPLECLANG_LIBS=rt
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DJELLYFISH_ROOT=/usr -DNO_NATIVE_ARCH=true $(EXTRA)

override_dh_auto_build:
	dh_auto_build
	markdown_py -f README.html README.md

override_dh_clean:
	dh_clean README.html sample_data/sample_quasi_index/ sample_data/sample_quasi_index_ph/ sample_data/sample_quasi_map.sam sample_data/sample_quasi_map_ph.sam

## rapmap 0.14.1+dfsg

=== debian/changelog ===
rapmap (0.14.1+dfsg-2) unstable; urgency=medium

  * only amd64 due to compiling variants for Intel SSE extensions

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 13 Sep 2019 16:08:06 +0200

rapmap (0.14.1+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 23 Jul 2019 12:52:36 +0200

=== debian/control ===
--- 
+++ 
@@ -15,14 +15,14 @@
                libspdlog-dev,
                libtclap-dev,
                pkg-config,
-               python-markdown
+               python3-markdown
 Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/med-team/rapmap
 Vcs-Git: https://salsa.debian.org/med-team/rapmap.git
 Homepage: https://github.com/COMBINE-lab/RapMap
 
 Package: rapmap
-Architecture: any
+Architecture: amd64
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: rapid sensitive and accurate DNA read mapping via quasi-mapping

=== debian/rules ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 override_dh_auto_build:
 	dh_auto_build
-	markdown_py -f README.html README.md
+	python3 -m markdown -f README.html README.md
 
 override_dh_clean:
 	dh_clean README.html sample_data/sample_quasi_index/ sample_data/sample_quasi_index_ph/ sample_data/sample_quasi_map.sam sample_data/sample_quasi_map_ph.sam

## rapmap 0.15.0%2Bdfsg

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, rapmap-example-data
Restrictions: allow-stderr

## rapmap 0.15.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,30 +1,67 @@
-cmake_minimum_required (VERSION 3.1)
+cmake_minimum_required(VERSION 3.9)
+
+if(DEFINED ENV{CC})
+  set(CC $ENV{CC})
+else()
+  set(CC gcc)
+endif()
+message("CC: ${CC}")
+
+set(CC_VERSION "")
+if(${CC} MATCHES ^gcc-)
+  string(REGEX REPLACE "gcc-" "" CC_VERSION ${CC})
+endif()
+message("CC version: ${CC_VERSION}")
 
 enable_testing()
 
 project (RapMap)
 
-set(CPACK_PACKAGE_VERSION "0.6.0")
-SET(CPACK_PACKAGE_VERSION_MAJOR "0")
-set(CPACK_PACKAGE_VERSION_MINOR "6")
-set(CPACK_PACKAGE_VERSION_PATCH "0")
+# auto-populate version:
+# from https://stackoverflow.com/questions/47066115/cmake-get-version-from-multi-line-text-file
+file(READ "current_version.txt" ver)
+
+string(REGEX MATCH "VERSION_MAJOR ([0-9]*)" _ ${ver})
+set(ver_major ${CMAKE_MATCH_1})
+
+string(REGEX MATCH "VERSION_MINOR ([0-9]*)" _ ${ver})
+set(ver_minor ${CMAKE_MATCH_1})
+
+string(REGEX MATCH "VERSION_PATCH ([0-9]*)" _ ${ver})
+set(ver_patch ${CMAKE_MATCH_1})
+
+set(CPACK_PACKAGE_VERSION_MAJOR ${ver_major})
+set(CPACK_PACKAGE_VERSION_MINOR ${ver_minor})
+set(CPACK_PACKAGE_VERSION_PATCH ${ver_patch})
+
+set(CPACK_PACKAGE_VERSION "${ver_major}.${ver_minor}.${ver_patch}")
+message("version: ${CPACK_PACKAGE_VERSION}")
+
 set(PROJECT_VERSION ${CPACK_PACKAGE_VERSION})
 set(CPACK_GENERATOR "TGZ")
 set(CPACK_SOURCE_GENERATOR "TGZ")
 set(CPACK_PACKAGE_VENDOR "Stony Brook University")
-set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "RapMap - Wicked-fast quasi-mapping")
+set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "rapmap - fast transcriptome mapping")
 set(CPACK_PACKAGE_NAME
   "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 set(CPACK_SOURCE_PACKAGE_FILE_NAME
   "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}-Source")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")
-#include(FindSSE)
-#FindSSE ()
-#if(SSE4_2_FOUND)
-#    message("Enabling popcount")
-#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.2 -DEMPHF_USE_POPCOUNT")
-#endif(SSE4_2_FOUND)
+
+# Set a default build type if none was specified
+set(default_build_type "Release")
+
+if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
+  message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
+  set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE
+      STRING "Choose the type of build." FORCE)
+  # Set the possible values of build type for cmake-gui
+  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
+    "Debug" "Release")
+endif()
+
+include(CheckIPOSupported)
 
 if (APPLE)
 set (WARNING_IGNORE_FLAGS "-Wno-deprecated-register -Wno-unknon-pragmas -Wreturn-type -Werror=return-type")
@@ -50,6 +87,12 @@
 endif()
 
 set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -funroll-loops -fPIC -fomit-frame-pointer -O4 -DHAVE_ANSI_TERM ${WALL} -std=c++14")
+
+set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
+set(CXXSTDFLAG "-std=c++14")
+set(GCCVERSION "5.2")
 
 set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
 find_package(Threads REQUIRED)
@@ -74,8 +117,12 @@
 set( BOOST_EXTRA_FLAGS "--layout=tagged" )
 ## this get's set differently below if we
 ## are on clang & apple
-set (NON_APPLECLANG_LIBS gomp rt)
+set (NON_APPLECLANG_LIBS gomp)
 set (PTHREAD_LIB)
+
+if(UNIX AND NOT APPLE)
+  set(LIBRT rt)
+endif()
 
 ##
 # Compiler-specific C++11 activation.

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,8 @@
     stringpiece.cc
     xxhash.c
     bit_array.c
+    edlib.cpp
+    metro/metrohash64.cpp
     #RapMapIndex.cpp
     #RapMapMapper.cpp
     #RapMapIndexer.cpp
@@ -64,6 +66,48 @@
 set (SUFFARRAY_LIB ${GAT_SOURCE_DIR}/external/install/lib/libdivsufsort.a)
 set (SUFFARRAY64_LIB ${GAT_SOURCE_DIR}/external/install/lib/libdivsufsort64.a)
 
+# build KSW2 library
+set (KSW2PP_BASIC_LIB_SRCS
+ksw2pp/kalloc.c
+ksw2pp/ksw2_extd.c
+ksw2pp/ksw2_extz.c
+ksw2pp/ksw2_gg.c
+ksw2pp/ksw2_gg2.c
+ksw2pp/ksw2_gg2_sse.c
+ksw2pp/KSW2Aligner.cpp
+)
+
+set (KSW2PP_ADVANCED_LIB_SRCS
+ksw2pp/ksw2_extd2_sse.c
+ksw2pp/ksw2_extf2_sse.c
+ksw2pp/ksw2_extz2_sse.c
+)
+
+# check if we know how to do IPO
+check_ipo_supported(RESULT HAS_IPOHAS_IPO)
+
+add_library(ksw2pp_sse2 OBJECT ${KSW2PP_ADVANCED_LIB_SRCS})
+add_library(ksw2pp_sse4 OBJECT ${KSW2PP_ADVANCED_LIB_SRCS})
+add_library(ksw2pp_basic OBJECT ${KSW2PP_BASIC_LIB_SRCS})
+
+set_target_properties(ksw2pp_sse2 PROPERTIES COMPILE_FLAGS "-O3 -msse2 -mno-sse4.1")
+set_target_properties(ksw2pp_sse2 PROPERTIES COMPILE_DEFINITIONS "KSW_CPU_DISPATCH;KSW_SSE2_ONLY;HAVE_KALLOC")
+set_target_properties(ksw2pp_sse4 PROPERTIES COMPILE_FLAGS "-O3 -msse4.1")
+set_target_properties(ksw2pp_sse4 PROPERTIES COMPILE_DEFINITIONS "KSW_CPU_DISPATCH;HAVE_KALLOC")
+set_target_properties(ksw2pp_basic PROPERTIES COMPILE_DEFINITIONS "KSW_CPU_DISPATCH;HAVE_KALLOC")
+
+set_target_properties(ksw2pp_basic PROPERTIES INCLUDE_DIRECTORIES ${GAT_SOURCE_DIR}/include)
+set_target_properties(ksw2pp_sse4 PROPERTIES INCLUDE_DIRECTORIES ${GAT_SOURCE_DIR}/include)
+
+# Build the ksw2pp library
+add_library(ksw2pp STATIC $<TARGET_OBJECTS:ksw2pp_sse2> $<TARGET_OBJECTS:ksw2pp_sse4> $<TARGET_OBJECTS:ksw2pp_basic>)
+set_target_properties(ksw2pp PROPERTIES COMPILE_DEFINITIONS "KSW_CPU_DISPATCH;HAVE_KALLOC")
+if(HAS_IPO)
+  set_property(TARGET ksw2pp PROPERTY INTERPROCEDURAL_OPTIMIZATION True)
+endif()
+
+
+
 # Link the executable
 target_link_libraries(rapmap
     # ${PTHREAD_LIB}
@@ -74,6 +118,9 @@
     ${NON_APPLECLANG_LIBS}
     ${FAST_MALLOC_LIB}
     ${CMAKE_THREAD_LIBS_INIT}
+    ${LIBRT}
+    ksw2pp
+    ${CMAKE_DL_LIBS}
     #${GAT_SOURCE_DIR}/external/install/lib/libjellyfish-2.0.a
     #${LIBLZMA_LIBRARIES}
 )

=== debian/changelog ===
rapmap (0.15.0+dfsg-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 12
  * Standards-Version: 4.4.0
  * Trim trailing whitespace.
  * Set upstream metadata fields: Repository.
  * -dev, -examples are Multi-Arch: foreign

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 14 Nov 2019 14:45:15 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
            Michael R. Crusoe <michael.crusoe@gmail.com>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                zlib1g-dev,
                libdivsufsort-dev,
@@ -15,8 +15,9 @@
                libspdlog-dev,
                libtclap-dev,
                pkg-config,
-               python3-markdown
-Standards-Version: 4.3.0
+               python3-markdown,
+               python3
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/med-team/rapmap
 Vcs-Git: https://salsa.debian.org/med-team/rapmap.git
 Homepage: https://github.com/COMBINE-lab/RapMap
@@ -52,6 +53,7 @@
 
 Package: rapmap-example-data
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Recommends: rapmap
 Description: example data for rapmap - rapid sensitive and accurate DNA read mapping
@@ -70,6 +72,7 @@
 
 Package: rapmap-dev
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: rapmap - rapid sensitive and accurate DNA read mapping (some headers)
  RapMap is a testing ground for ideas in quasi-mapping / (lightweight /

=== debian/rules ===
--- 
+++ 
@@ -24,5 +24,3 @@
 
 override_dh_clean:
 	dh_clean README.html sample_data/sample_quasi_index/ sample_data/sample_quasi_index_ph/ sample_data/sample_quasi_map.sam sample_data/sample_quasi_map_ph.sam
-
-

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
   https://github.com/COMBINE-lab/RapMap/releases .*/archive/[salmon-]*v?(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
